/*
    multi-demension array (dynamically allocated)
*/

#include <stdio.h>
#include <stdlib.h>

static int tarai(int, int, int);
static inline int tarai0(int, int, int);
static void initialize_cache_table(int);

#if 0
static void
check_density(void)
{
    int len = (K1+2) * (K1+2) * (K1+2);
    int empty = 0;
    int i;

    for (i = 0; i < len; i++) {
        if (cache[i] == -2) {
            empty++;
        }
    }
    printf("%d / %d = empty / total\n", empty, len);
}
#endif

#define max3(a,b,c) max(max(a,b),c)
#define max(x,y) ((x) > (y) ? (x) : (y))

int
main(int argc, char **argv)
{
    int k1, k2, k3;

    if (argc != 4) {
        fprintf(stderr, "Usage: ./memo-tarai2 x y z\n");
        exit(1);
    }
    k1 = atoi(argv[1]);
    k2 = atoi(argv[2]);
    k3 = atoi(argv[3]);
    initialize_cache_table(max3(k1, k2, k3) + 2);
    printf("%d\n", tarai(k1, k2, k3));
    /* check_density(); */
    exit(0);
}

static int *cache;
static int table_width;

static void
initialize_cache_table(int width)
{
    int i, j, k;

    table_width = width;
    cache = malloc(width * width * width * sizeof(int));
    if (!cache) {
        fprintf(stderr, "malloc failed\n");
        exit(3);
    }
    for (i = 0; i < width; i++) {
        for (j = 0; j < width; j++) {
            for (k = 0; k < width; k++) {
                cache[(i * width * width) + (j * width) + k] = -2;
            }
        }
    }
}

static int
tarai(int x, int y, int z)
{
    int result;
    int key;
    int w = table_width;

    key = ((x+1)*w*w) + ((y+1)*w) + (z+1);
    result = cache[key];
    if (result != -2)
        return result;
    result = tarai0(x, y, z);
    cache[key] = result;
    return result;
}

static inline int
tarai0(int x, int y, int z)
{
    if (x <= y) return y;
    return tarai(tarai(x-1, y, z),
                 tarai(y-1, z, x),
                 tarai(z-1, x, y));
}
