/*
    pointer array
*/

#include <stdio.h>
#include <stdlib.h>

static void *new_cache(void*);
static int tarai(int, int, int);
static inline int tarai0(int, int, int);

#define max3(a,b,c) max(max(a,b),c)
#define max(x,y) ((x) > (y) ? (x) : (y))

void **cache;
int cache_size;

int
main(int argc, char **argv)
{
    int k1, k2, k3;

    if (argc != 4) {
        fprintf(stderr, "Usage: ./memo-tarai3 x y z\n");
        exit(1);
    }
    k1 = atoi(argv[1]);
    k2 = atoi(argv[2]);
    k3 = atoi(argv[3]);
    cache_size = max3(k1, k2, k3) + 2;
    cache = new_cache(0);
    printf("%d\n", tarai(k1, k2, k3));
    exit(0);
}

static void*
new_cache(void *val)
{
    void **p;
    int i;

    p = malloc(sizeof(void**) * cache_size);
    if (!p) {
        fprintf(stderr, "malloc failed\n");
        exit(3);
    }
    for (i = 0; i < cache_size; i++) {
        p[i] = val;
    }
    return p;
}

static int
tarai(int x, int y, int z)
{
    void **p1, **p2;
    int result;

    if (!(p1 = cache[x+1])) {
        cache[x+1] = p1 = new_cache(0);
    }
    if (!(p2 = p1[y])) {
        p1[y] = p2 = new_cache(-2);
    }
    if ((result = p2[z]) == -2) {
        p2[z] = result = tarai0(x,y,z);
    }
    return result;
}

static inline int
tarai0(int x, int y, int z)
{
    if (x <= y) return y;
    return tarai(tarai(x-1, y, z),
                 tarai(y-1, z, x),
                 tarai(z-1, x, y));
}
