/*
    hash table
*/

#include <stdio.h>
#include <stdlib.h>
#include "st.h"

#define K1 768
#define K2 384
#define K3 0

static int tarai(int, int, int);
static inline int tarai0(int, int, int);

st_table *cache;

int
main(int argc, char **argv)
{
    if (argc != 4) {
        fprintf(stderr, "Usage: ./memo-tarai4 x y z\n");
        exit(1);
    }
    cache = st_init_numtable();
    printf("%d\n", tarai(atoi(argv[1]), atoi(argv[2]), atoi(argv[3])));
    exit(0);
}

static int
tarai(int x, int y, int z)
{
    st_table *t1, *t2;
    int result;

    if (!st_lookup(cache, x, &t1)) {
        t1 = st_init_numtable();
        st_add_direct(cache, x, t1);
    }
    if (!st_lookup(t1, y, &t2)) {
        t2 = st_init_numtable();
        st_add_direct(t1, y, t2);
    }
    if (!st_lookup(t2, z, &result)) {
        result = tarai0(x,y,z);
        st_add_direct(t2, z, result);
    }
    return result;
}

static inline int
tarai0(int x, int y, int z)
{
    if (x <= y) return y;
    return tarai(tarai(x-1, y, z),
                 tarai(y-1, z, x),
                 tarai(z-1, x, y));
}
