#
# Utilize Object#to_int
#
# Author: Nobuyoshi Nakada
# modified by Minero Aoki
#

class Tarai

  include Comparable

  def initialize(x, y, z)
    @x, @y, @z = x, y, z
    @t = 0
  end

  def tarai_inspect(level = 3)
    return "?" if (level -= 1) < 0
    s = "Tarai(" <<
        [@x, @y, @z].map {|x| Tarai === x ? x.tarai_inspect(level) : x}.join(", ") <<
        ")"
    s << ("%#d" % @t) unless @t.zero?
    s
  end

  def +(val)
    @t += val
  end

  def -(val)
    @t -= val
  end

  def <=>(val)
    to_int() <=> val.to_int
  end

  def coerce(val)
    case val
    when Integer
      [val, to_int()]
    else
      super
    end
  end

  def to_int
    @t += if !@x
            0
          elsif @x <= @y
            @y
          else
            Tarai.new(Tarai.new(@x-1, @y, @z),
                      Tarai.new(@y-1, @z, @x),
                      Tarai.new(@z-1, @x, @y)).to_i
          end
    @x = nil
    @t
  end

  alias to_i to_int

  def to_s
    to_i.to_s
  end

end


t = Tarai.new(*ARGV.map {|n| n.to_i })
puts "#{t.inspect} = #{t}"
